package com.smith9.geiger.client.beans

import org.joda.time.DateTime
import simplygroovy.bean.Period
/**
 * Created: Mar 17, 2011
 * @author david
 */
class Count implements Stat {
    public static final String FORMAT = "dd/MM/yyyy hh.mm.ss.SSS"
    DateTime periodStart
    Period period
    String category
    String subCategory
    String productName
    String environment
    String subProduct
    boolean failure = false
    int count = 0
    Double min
    Double max
    Double sum

    public String toString ( ) {
    return "Count{" +
    "environment='" + environment + '\'' +
    ", product='" + productName + '\'' +
    ", subProduct='" + subProduct + '\'' +
    ", periodStart=" + periodStart +
    ", failure=" + failure +
    ", period=" + period +
    ", category=" + category +
    ", subCategory=" + subCategory +
    ", count=" + count +
    ", min=" + min +
    ", max=" + max +
    ", sum=" + sum +
    '}' ;
    }
    public void validate() {
        if(!period) {
            throw new IllegalStateException("Period must be set")
        }
        if(!category) {
            throw new IllegalStateException("Category must be set")
        }
        if(!periodStart) {
            throw new IllegalStateException("Period Start must be set")
        }
        if(!productName) {
            throw new IllegalStateException("Product Name must be set")
        }
    }
    public String key() {
        return ([environment, productName, subProduct, period, category, subCategory, failure, periodStart.toString(FORMAT)]).join(':')

    }
    public void merge(Count addCount) {
        count += addCount.count
        min = ([min, addCount.min] - null).min()
        max = ([max, addCount.max] - null).max()
        sum = ([sum, addCount.sum] - null).sum()
    }
}